var Generator = require('yeoman-generator');
const chalk = require("chalk");
const yosay = require("yosay");
const mkdirp = require("mkdirp");
module.exports = class extends Generator {
  // The name `constructor` is important here
  constructor(args, opts) {
    // Calling the super constructor is important so our generator is correctly set up
    super(args, opts);
    this.argument("projectname", { type: String, required: true });

    this.option("typeScript");
    // And you can then access it later; e.g.
    this.isTypeScript = this.options.typeScript ? ".ts" : ".js";
  }
  async prompting() {
    this.log(
      yosay(
        `欢迎使用 ${chalk.red(
          "cbg-cli"
        )} 让我们开始吧！`
      )
    );
    this.answers = await this.prompt([
      // {
      //   type: "input",
      //   name: "name",
      //   message: "Your project name",
      //   default: this.appname // Default to current folder name
      // },
      // {
      //   type: "confirm",
      //   name: "cool",
      //   message: "Would you like to enable the Cool feature?"
      // }
    ]);

    // this.log("app name", answers.name);
    // this.log("cool feature", answers.cool);
  }

  default() {
    if (this.options.projectname) {
      this.log(`\nYour generator must be inside a folder named
        ${this.options.projectname}\n
        I will automatically create this folder.\n`);

      mkdirp(this.options.projectname);
      this.destinationRoot(this.destinationPath(this.options.projectname));
    }
  }

  writing() {
    // this.log("cool feature", this.answers.cool); // user answer `cool` used
    // this.log(this.options.projectname);
    // this.log(this.isTypeScript);
    // const pkgJson = {
    //   "scripts": {
    //     "dev": "vite",
    //     "build": "vite build",
    //     "serve": "vite preview"
    //   },
    //   "dependencies": {
    //     "@vitejs/plugin-vue-jsx": "^1.1.0",
    //     "ant-design-vue": "^2.0.0",
    //     "mockjs": "^1.1.0",
    //     "moment": "^2.29.1",
    //     "rollup-plugin-esm-import-to-url": "^2.1.0",
    //     "vue": "^3.0.5",
    //     "vue-router": "^4.0.4",
    //     "vuex": "^4.0.0",
    //     "yeoman-generator": "^1.0.0"
    //   },
    //   "devDependencies": {
    //     "@vitejs/plugin-vue": "^1.1.4",
    //     "@vue/compiler-sfc": "^3.0.5",
    //     "less": "^4.1.1",
    //     "rollup-plugin-commonjs": "^10.1.0",
    //     "rollup-plugin-external-globals": "^0.6.1",
    //     "sass": "^1.32.8",
    //     "vite": "^2.0.1",
    //     "vite-plugin-mock": "^2.5.0",
    //     "vite-plugin-style-import": "^0.9.2"
    //   }
    // };

    // // Extend or create package.json file in destination path
    // this.fs.extendJSON(this.destinationPath('package.json'), pkgJson);

    const templates = [
      'build',
      '.gitignore',
      'package.json',
      'README.md',
      'public',
      'src',
      '.env',
      '.env.development',
      '.env.production',
      '.gitignore',
      'index.html',
      'jsconfig.json',
      'vite.config.js'
    ]
    templates.forEach(item => {
      // 遍历每个文件路径 item
      this.fs.copyTpl(
        this.templatePath(item),
        this.destinationPath(item),
        this.answers
      )
    })
  }
  install() {
    this.npmInstall();
  }
  end() {
    this.log(`\n
    next you can \n
    cd ${this.options.projectname}\n
    npm run dev\n`)
  }
};