import { RouteRecordRaw } from 'vue-router'
import mainPageRoutes from '/@/router/mainPageRoutes'
import { globalStore } from '/@/store/modules/global';
import { RouteMeta } from './types'

function recursionPermission(i, j) {
  let arr = []
  if (i && j) {
    i.forEach(item => {
      j.forEach(jItem => {
        if ((item.name === jItem.rule && jItem.status === 1) || item.type === 'noCheck') {
          if (item.children && jItem.children) {
            item.children = recursionPermission(item.children, jItem.children)
          }
          arr.push(item)
        }
      })
    })
  }
  return arr
}

function filterPermission(PERMISSION) {
  const PERMISSION_ARR = JSON.parse(PERMISSION)
  let arr = recursionPermission(mainPageRoutes, PERMISSION_ARR)
  return arr
}

export function createPermissionGuard() {
  let arr = []
  const PERMISSION = localStorage.getItem('PERMISSION')
  if (PERMISSION) arr = filterPermission(PERMISSION)
  globalStore.SET_MENUS(arr)
  if (!arr.length) {
    arr.push({
      path: '/tenement',
      name: 'tenement',
      component: () => import('/@/views/tenement/Index'),
      meta: {
        title: '租户管理',
        menuPath: 'tenement',
        icon: ''
      }
    })
  }
  return arr
}
