import { computed, onMounted, onUnmounted, onUpdated, reactive, ref, unref, watch } from 'vue'
import { Button } from 'ant-design-vue'
const Child = {
  props: {
    name: {
      type: String,
      default() {
        return ''
      }
    },
    slotDom: {
      type: Function,
      default() {
        return <span></span>
      }
    }
  },
  setup(props, { emit }) {
    const handleAdd = () => {
      emit('handleAdd', '来自子组件的数据')
    }
    return () => (
      <div style="margin-top: 10px;">
        childName: {props.name}
        <Button style="margin-left: 50px" onClick={handleAdd}>alert子组件数据</Button>
        {
          props.slotDom()
        }
      </div>
    )
  }
}

export default Child
